//////////////////////////////////////
//  Program Name: WINSTYLE.H
//  Programmer: Charlie Calvert
//  Description: WinStyle windows program
//  Date: 04/03/93
//////////////////////////////////////

// Const
#define CM_ARRANGE  1
#define CM_WHISTLE  2
#define CM_EXIT 3
#define CM_HELP 4
#define CM_BLUE     101
#define CM_RED 102
#define CM_GREEN 103
#define CM_SPECIAL1 104
#define CM_SPECIAL2 105
#define CM_SPECIAL3 106

DWORD Styles[] = { WS_POPUP | WS_VISIBLE,
                   WS_POPUP | WS_VISIBLE | WS_CAPTION,
                   WS_POPUP | WS_VISIBLE | WS_CAPTION | \
                    WS_MINIMIZEBOX | WS_MAXIMIZEBOX,
                   WS_POPUP | WS_VISIBLE | WS_CAPTION | \
                    WS_HSCROLL | WS_VSCROLL,
                   WS_OVERLAPPEDWINDOW | WS_VISIBLE,
                   WS_CHILDWINDOW | WS_VISIBLE,
                   WS_CHILDWINDOW | WS_VISIBLE | WS_THICKFRAME,
                   WS_CHILDWINDOW | WS_VISIBLE | WS_BORDER | \
                    WS_CAPTION,
                   WS_CHILDWINDOW | WS_VISIBLE | WS_CAPTION | \
                    WS_DISABLED,
                   WS_OVERLAPPEDWINDOW | WS_VISIBLE
                 };

char *szStyles[] = { "WS_POPUP | WS_VISIBLE",
                    "WS_POPUP | WS_VISIBLE | WS_CAPTION",
                    "WS_POPUP | WS_VISIBLE | WS_CAPTION | \
                      WS_MINIMIZEBOX | WS_MAXIMIZEBOX",
                    "WS_POPUP | WS_VISIBLE | WS_CAPTION | \
                      WS_HSCROLL | WS_VSCROLL",
                    "WS_OVERLAPPEDWINDOW | WS_VISIBLE",
                    "WS_CHILDWINDOW | WS_VISIBLE",
                    "WS_CHILDWINDOW | WS_VISIBLE | \
                      WS_THICKFRAME",
                    "WS_CHILDWINDOW | WS_VISIBLE | WS_BORDER | \
                      WS_CAPTION",
                    "WS_CHILDWINDOW | WS_VISIBLE | WS_CAPTION | \
                      WS_DISABLED",
                    "WS_OVERLAPPEDWINDOW | WS_VISIBLE"
                    };

// Declarations for class WinStyle
#define WinStyle_DefProc    DefWindowProc
BOOL WinStyle_OnCreate(HWND hwnd, CREATESTRUCT FAR* lpCreateStruct);
void WinStyle_OnDestroy(HWND hwnd);
void WinStyle_OnCommand(HWND hwnd, int id, HWND hwndCtl,
                        UINT codeNotify);

#define StyleChild_DefProc    DefWindowProc
void StyleChild_OnPaint(HWND hwnd);
void StyleChild_OnLButtonDown(HWND hwnd, BOOL fDoubleClick,
                              int x, int y, UINT keyFlags);

// Variables
HWND ChildWindows[10];
HBRUSH hPurpleHaze;
HBITMAP Pattern1, Pattern2, Pattern3;

// Parent Procs
LRESULT CALLBACK _export WndProc(HWND hWindow, UINT Message,
                                 WPARAM wParam, LPARAM lParam);
BOOL Register(HINSTANCE hInst);
HWND Create(HINSTANCE hInst, int nCmdShow);

// Child Procs
LRESULT CALLBACK _export ChildWndProc(HWND hwnd, UINT Message,
                                 WPARAM wParam, LPARAM lParam);
